JUCE: UndoableAction Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
UndoableAction Class Referenceabstract
juce_data_structures » undomanager

Used by the UndoManager class to store an action which can be done and undone. More...

`#include <juce_UndoableAction.h>`

## Public Member Functions
virtual | ~UndoableAction ()=default
| Destructor.
virtual bool | perform ()=0
| Overridden by a subclass to perform the action.
virtual bool | undo ()=0
| Overridden by a subclass to undo the action.
virtual int | getSizeInUnits ()
| Returns a value to indicate how much memory this object takes up.
virtual UndoableAction * | createCoalescedAction (UndoableAction *nextAction)
| Allows multiple actions to be coalesced into a single action object, to reduce storage space.

## Protected Member Functions
| UndoableAction ()=default
| Creates an action.

## Detailed Description

Used by the UndoManager class to store an action which can be done and undone.

See also
  UndoManager

## Constructor & Destructor Documentation

## ◆ UndoableAction()

UndoableAction::UndoableAction | ( |  | ) |
| protecteddefault

Creates an action.

## ◆ ~UndoableAction()

virtual UndoableAction::~UndoableAction | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ perform()

virtual bool UndoableAction::perform | ( |  | ) |
| pure virtual

Overridden by a subclass to perform the action.

This method is called by the UndoManager, and shouldn't be used directly by applications.

Be careful not to make any calls in a perform() method that could call recursively back into the UndoManager::perform() method

Returns
  true if the action could be performed.

See also
  UndoManager::perform

## ◆ undo()

virtual bool UndoableAction::undo | ( |  | ) |
| pure virtual

Overridden by a subclass to undo the action.

This method is called by the UndoManager, and shouldn't be used directly by applications.

Be careful not to make any calls in an undo() method that could call recursively back into the UndoManager::perform() method

Returns
  true if the action could be undone without any errors.

See also
  UndoManager::perform

## ◆ getSizeInUnits()

virtual int UndoableAction::getSizeInUnits | ( |  | ) |
| virtual

Returns a value to indicate how much memory this object takes up.

Because the UndoManager keeps a list of UndoableActions, this is used to work out how much space each one will take up, so that the UndoManager can work out how many to keep.

The default value returned here is 10 - units are arbitrary and don't have to be accurate.

See also
  UndoManager::getNumberOfUnitsTakenUpByStoredCommands, UndoManager::setMaxNumberOfStoredUnits

## ◆ createCoalescedAction()

virtual UndoableAction * UndoableAction::createCoalescedAction | ( | UndoableAction * | nextAction | ) |
| virtual

Allows multiple actions to be coalesced into a single action object, to reduce storage space.

If possible, this method should create and return a single action that does the same job as this one followed by the supplied action.

If it's not possible to merge the two actions, the method should return a nullptr.

The documentation for this class was generated from the following file:

- juce_UndoableAction.h